def teste_TAD_posicao():
    total_score = 50
    fun_name = teste_barreiras_TAD_posicao


    |custom_import(['TAD_posicao'])
    p = cria_posicao(5,3)
    p_adj = obter_posicoes_adjacentes(p)
    hyp = ', '.join((posicao_para_str(a) for a in p_adj))
    ref = '(5, 2), (6, 3), (5, 4), (4, 3)'
    hyp == ref
    # True

    |custom_import(['TAD_posicao'])
    p = cria_posicao(5, 2), cria_posicao(6, 3), cria_posicao(5, 4), cria_posicao(4, 3) 
    p_adj = ordenar_posicoes(p)
    hyp = ', '.join((posicao_para_str(a) for a in p_adj))
    ref = '(5, 2), (4, 3), (6, 3), (5, 4)'
    hyp == ref
    # True

    return

def teste_TAD_animal():
    total_score = 50
    fun_name = teste_barreiras_TAD_animal


    |custom_import(['TAD_animal'])
    a = cria_animal('aranha', 2, 1)
    a = aumenta_idade(a)
    eh_animal_fertil(a)
    # False

    |custom_import(['TAD_animal'])
    a = cria_animal('aranha', 2, 1)
    a = aumenta_fome(a)
    eh_animal_faminto(a)
    # True

    |custom_import(['TAD_animal'])
    a = cria_animal('formiga', 1, 0)
    n = reproduz_animal(a)
    animais_iguais(a, n)
    # True

    return


def teste_TAD_prado():
    total_score = 100
    fun_name = teste_barreiras_TAD_prado


    |custom_import(['TF_posicao'])
    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = mover_animal(m, cria_posicao(3,1), cria_posicao(8,8))
    ', '.join(posicao_para_str(u) for u in obter_posicao_animais(m))
    # (1, 1), (2, 2), (5, 3), (8, 8)

    |custom_import(['TF_posicao'])
    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(1,1)
    eh_posicao_animal(m, p)
    # True

    |custom_import(['TF_posicao'])
    d = cria_posicao(14, 4)
    w = (cria_posicao(10, 3), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    prado_para_str(m)
    # +-------------+\\n|p.p@.........|\\n|.G...........|\\n|@...p....@...|\\n+-------------+

    |custom_import(['TF_animal'])
    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = mover_animal(m, cria_posicao(3,1), cria_posicao(8,8))
    ', '.join(posicao_para_str(u) for u in obter_posicao_animais(m))
    # (1, 1), (2, 2), (5, 3), (8, 8)


    |custom_import(['TF_animal'])
    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(1,1)
    eh_posicao_animal(m, p)
    # True

    |custom_import(['TF_animal'])
    d = cria_posicao(14, 4)
    w = (cria_posicao(10, 3), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    prado_para_str(m)
    # +-------------+\\n|p.p@.........|\\n|.G...........|\\n|@...p....@...|\\n+-------------+

    |custom_import(['TF_posicao', 'TF_animal'])
    d = cria_posicao(15, 15)
    w = ()
    a = tuple(cria_animal('leao', 20, 4) for i in range(1)) + tuple(cria_animal('zebra', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    t = mover_animal(m, cria_posicao(3,1), cria_posicao(8,8))
    ', '.join(posicao_para_str(u) for u in obter_posicao_animais(m))
    # (1, 1), (2, 2), (5, 3), (8, 8)

    |custom_import(['TF_posicao', 'TF_animal'])
    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    p = cria_posicao(1,1)
    eh_posicao_animal(m, p)
    # True

    |custom_import(['TF_posicao', 'TF_animal'])
    d = cria_posicao(14, 4)
    w = (cria_posicao(10, 3), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    prado_para_str(m)
    # +-------------+\\n|p.p@.........|\\n|.G...........|\\n|@...p....@...|\\n+-------------+

    return



def teste_FAN_prado():
    total_score = 50
    fun_name = teste_barreiras_FAN_prado

    |custom_import(['TF_posicao', 'TF_animal', 'TAD_prado'])
    d = cria_posicao(14, 4)
    w = (cria_posicao(10, 3), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    obter_valor_numerico(m, cria_posicao(14, 4))
    # 74

    |custom_import(['TF_posicao', 'TF_animal', 'TAD_prado'])
    d = cria_posicao(6, 4)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('gato', 20, 4) for i in range(1)) + tuple(cria_animal('pombo', 10, 0) for i in range(3))
    p = tuple(cria_posicao(*p) for p in ((2, 2), (1, 1), (3, 1), (5, 3)))
    m = cria_prado(d, w, a, p)
    posicao_para_str(obter_movimento(m, cria_posicao(2,2)))
    # (2, 1)

    return


def teste_FAN_geracao():
    total_score = 75
    fun_name = teste_barreiras_geracao

    |custom_import(['TF_posicao', 'TF_animal', 'TF_prado'])
    d = cria_posicao(7, 7)
    w = (cria_posicao(4, 2), cria_posicao(4, 1), cria_posicao(1, 3))
    a = tuple(cria_animal('lizzard', 20, 4) for i in range(3)) + tuple(cria_animal('fly', 10, 0) for i in range(5))
    p = tuple(cria_posicao(*p) for p in (((2, 5), (1, 1), (2, 4),(3, 1), (5, 3), (2, 6), (1, 5), (3, 5))))
    m = cria_prado(d, w, a, p)
    t = geracao(m)
    prado_para_str(m)
    # +------+\\n|.f.@..|\\n|L..@..|\\n|@....f|\\n|..L...|\\n|.fL...|\\n|f.....|\\n+------+

    return


def teste_FAN_simula():
    total_score = 75
    fun_name = teste_barreiras_simula_eco

    |custom_import(['TF_posicao', 'TF_animal', 'TF_prado', 'FAN_geracao'])
    path = '/home/fpshak/data/contests/FP2122P2/'
    simula_ecossistema(path + 'public_test_config.txt', 20, False)
    # Predadores: 1 vs Presas: 3 (Gen. 0)\n+----------+\n|..........|\n|.mL@@....m|\n|...m......|\n+----------+\nPredadores: 0 vs Presas: 28 (Gen. 20)\n+----------+\n|mmmmmmmmmm|\n|mmm@@mmmmm|\n|mmmmmmmmmm|\n+----------+\n(0, 28)

    return

    
