
def geracao(prado):

    positions = obter_posicao_animais(prado)
    already_moved = ()

    while len(positions):
        current, positions = positions[0], positions[1:]
        if posicao_para_str(current) not in already_moved:
            animal = obter_animal(prado, current)

            aumenta_idade(animal)
            aumenta_fome(animal)

            new_pos = obter_movimento(prado, current)

            if not posicoes_iguais(current, new_pos):
                if eh_posicao_animal(prado, new_pos):   # Comer
                    reset_fome(animal)
                    eliminar_animal(prado, new_pos)
                    mover_animal(prado, current, new_pos)
                    already_moved += (posicao_para_str(new_pos),)
                else:                                   # mover sem comer
                    mover_animal(prado, current, new_pos)

                if eh_animal_fertil(animal):            # reproduzir
                    filho = reproduz_animal(obter_animal(prado, new_pos))
                    inserir_animal(prado, filho, current)

            if eh_animal_faminto(obter_animal(prado, new_pos)):
                eliminar_animal(prado, new_pos)

    return prado
