
###########################################
# TAD posicao                             #
# Operacoes basicas                       #
###########################################

from random import randint

# del cria_posicao,cria_copia_posicao,obter_pos_x,obter_pos_y,eh_posicao,posicoes_iguais,posicao_para_str

# Construtor
def cria_posicao(x, y): 
    if type(x) == int  and type(y) == int and x >= 0 and y >= 0:
        return ({'xx': x, 'yy': y}, 'blop', randint(0, 10**6))
    raise ValueError('cria_posicao: argumentos invalidos')

def cria_copia_posicao(pos):
    return cria_posicao(obter_pos_x(pos), obter_pos_y(pos))

# Selectores
def obter_pos_x(pos):
    return pos[0]['xx']

def obter_pos_y(pos):
    return pos[0]['yy']

# Reconhecedor
def eh_posicao(arg):
    return type(arg)==tuple and len(arg)==3 and \
           type(arg[0])==dict and len(arg[0])==2 and \
           'xx' in arg[0] and 'yy' in arg[0] and \
           type(arg[0]['xx']) == int and arg[0]['xx'] >= 0 and \
           type(arg[0]['yy']) == int and arg[0]['yy'] >= 0 and \
           type(arg[1])==str and arg[1]=='blop' and \
           isinstance(arg[2], int)

# Teste
def posicoes_iguais(pos1, pos2):
    return eh_posicao(pos1) and eh_posicao(pos2) and \
           obter_pos_x(pos1) == obter_pos_x(pos2) and \
           obter_pos_y(pos1) == obter_pos_y(pos2)

# Transformador
def posicao_para_str(pos):
    return '({}, {})'.format(obter_pos_x(pos), obter_pos_y(pos))

